stages:
    - build
    - test
    - deploy

# packaging
package:
  stage: build
  image: maven:3-openjdk-11
  script:
      - echo "debut du build"
      - export MAVEN_CLI_OPTS="--batch-mode --errors --fail-at-end --show-version"
      - mvn $MAVEN_CLI_OPTS package -DskipTests
  artifacts:
    paths:
      - target
    expire_in: 1 week
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .m2/repository
  tags:
      - damien.lassalle
      - docker

# systeme de test
system-test:
  stage: test
  image: maven:3-openjdk-11
  script:
      - echo "debut du test"
      - export MAVEN_CLI_OPTS="--batch-mode --errors --fail-at-end --show-version"
      - mvn $MAVEN_CLI_OPTS test
  services:
    - postgres:12.2-alpine
  variables:
    POSTGRES_DB: appdb
    POSTGRES_USER: pguser
    POSTGRES_PASSWORD: pgpass
    POSTGRES_HOST_AUTH_METHOD: trust
  artifacts:
    when: always
    reports:
      junit:
        - target/surefire-reports/TEST-*.xml
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .m2/repository
  tags:
      - damien.lassalle
      - docker

quakity-test:
  stage: test
  script:
      - echo "debut de quality"
  tags:
      - damien.lassalle
      - docker

deploy-staging:
  stage: deploy
  image: registry.gitlab.com/damien.lassalle/docker-ansible:latest
  script:
      - echo "Configure SSH"
      - export INVENTORY_FILE=inventory/staging.yml
      - cd deployment
      - echo "$ANSIBLE_PRIVATE_KEY" > .ansible_private_key
      - chmod 0600 .ansible_private_key
      - ansible-galaxy install -r roles/requirements.yml
      - ansible-playbook playbook.yml -i $INVENTORY_FILE --syntax-check
      - ansible-playbook playbook.yml -i $INVENTORY_FILE --private-key=.ansible_private_key
  variables:
      ANSIBLE_HOST_KEY_CHECKING: "false"
  environment:
    name: staging
    url: "http://157.230.124.26"
  tags:
      - damien.lassalle
      - docker
